# Plutonium framework API: pu::ui::elm::ProgressBar Class Reference

pu::ui::elm::ProgressBar Class Reference

`#include <elm_ProgressBar.hpp>`

Inheritance diagram for pu::ui::elm::ProgressBar:

## Public Member Functions

| ProgressBar (const i32 x, const i32 y, const i32 width, const i32 height, const double max_val)
i32 | GetX () override
void | SetX (const i32 x)
i32 | GetY () override
void | SetY (const i32 y)
i32 | GetWidth () override
void | SetWidth (const i32 width)
i32 | GetHeight () override
void | SetHeight (const i32 height)
Color | GetProgressColor ()
void | SetProgressColor (const Color progress_clr)
Color | GetBackgroundColor ()
void | SetBackgroundColor (const Color bg_clr)
double | GetProgress ()
void | SetProgress (const double progress)
void | IncrementProgress (const double extra_progress)
void | DecrementProgress (const double extra_progress)
void | SetMaxProgress (const double max_progress)
double | GetMaxProgress ()
void | FillProgress ()
void | ClearProgress ()
bool | IsCompleted ()
void | OnRender (render::Renderer::Ref &drawer, const i32 x, const i32 y) override
void | OnInput (const u64 keys_down, const u64 keys_up, const u64 keys_held, const TouchPoint touch_pos) override
Public Member Functions inherited from pu::ui::elm::Element
| Element ()
virtual | ~Element ()
virtual i32 | GetX ()=0
virtual i32 | GetY ()=0
virtual i32 | GetWidth ()=0
virtual i32 | GetHeight ()=0
virtual void | OnRender (render::Renderer::Ref &drawer, const i32 x, const i32 y)=0
virtual void | OnInput (const u64 keys_down, const u64 keys_up, const u64 keys_held, const TouchPoint touch_pos)=0
bool | IsVisible ()
void | SetVisible (const bool visible)
void | SetHorizontalAlign (const HorizontalAlign align)
HorizontalAlign | GetHorizontalAlign ()
void | SetVerticalAlign (const VerticalAlign align)
VerticalAlign | GetVerticalAlign ()
void | SetParentContainer (Container *parent_container)
i32 | GetProcessedX ()
i32 | GetProcessedY ()

## Static Public Attributes

static constexpr Color | DefaultProgressColor = { 139, 195, 74, 255 }
static constexpr Color | DefaultBackgroundColor = { 140, 140, 140, 255 }

## Additional Inherited Members

Protected Attributes inherited from pu::ui::elm::Element
bool | visible
HorizontalAlign | h_align
VerticalAlign | v_align
Container * | parent_container

## Constructor & Destructor Documentation

## ProgressBar()

pu::ui::elm::ProgressBar::ProgressBar | ( | const i32 | x,
|  | const i32 | y,
|  | const i32 | width,
|  | const i32 | height,
|  | const double | max_val
| ) |  |

inline

## Member Function Documentation

## ClearProgress()

void pu::ui::elm::ProgressBar::ClearProgress | ( |  | ) |

inline

## DecrementProgress()

void pu::ui::elm::ProgressBar::DecrementProgress | ( | const double | extra_progress | ) |

inline

## FillProgress()

void pu::ui::elm::ProgressBar::FillProgress | ( |  | ) |

inline

## GetBackgroundColor()

Color pu::ui::elm::ProgressBar::GetBackgroundColor | ( |  | ) |

inline

## GetHeight()

i32 pu::ui::elm::ProgressBar::GetHeight | ( |  | ) |

inlineoverridevirtual

Implements pu::ui::elm::Element.

## GetMaxProgress()

double pu::ui::elm::ProgressBar::GetMaxProgress | ( |  | ) |

inline

## GetProgress()

double pu::ui::elm::ProgressBar::GetProgress | ( |  | ) |

inline

## GetProgressColor()

Color pu::ui::elm::ProgressBar::GetProgressColor | ( |  | ) |

inline

## GetWidth()

i32 pu::ui::elm::ProgressBar::GetWidth | ( |  | ) |

inlineoverridevirtual

Implements pu::ui::elm::Element.

## GetX()

i32 pu::ui::elm::ProgressBar::GetX | ( |  | ) |

inlineoverridevirtual

Implements pu::ui::elm::Element.

## GetY()

i32 pu::ui::elm::ProgressBar::GetY | ( |  | ) |

inlineoverridevirtual

Implements pu::ui::elm::Element.

## IncrementProgress()

void pu::ui::elm::ProgressBar::IncrementProgress | ( | const double | extra_progress | ) |

inline

## IsCompleted()

bool pu::ui::elm::ProgressBar::IsCompleted | ( |  | ) |

inline

## OnInput()

void pu::ui::elm::ProgressBar::OnInput | ( | const u64 | keys_down,
|  | const u64 | keys_up,
|  | const u64 | keys_held,
|  | const TouchPoint | touch_pos
| ) |  |

inlineoverridevirtual

Implements pu::ui::elm::Element.

## OnRender()

void pu::ui::elm::ProgressBar::OnRender | ( | render::Renderer::Ref & | drawer,
|  | const i32 | x,
|  | const i32 | y
| ) |  |

overridevirtual

Implements pu::ui::elm::Element.

## SetBackgroundColor()

void pu::ui::elm::ProgressBar::SetBackgroundColor | ( | const Color | bg_clr | ) |

inline

## SetHeight()

void pu::ui::elm::ProgressBar::SetHeight | ( | const i32 | height | ) |

inline

## SetMaxProgress()

void pu::ui::elm::ProgressBar::SetMaxProgress | ( | const double | max_progress | ) |

inline

## SetProgress()

void pu::ui::elm::ProgressBar::SetProgress | ( | const double | progress | ) |

## SetProgressColor()

void pu::ui::elm::ProgressBar::SetProgressColor | ( | const Color | progress_clr | ) |

inline

## SetWidth()

void pu::ui::elm::ProgressBar::SetWidth | ( | const i32 | width | ) |

inline

## SetX()

void pu::ui::elm::ProgressBar::SetX | ( | const i32 | x | ) |

inline

## SetY()

void pu::ui::elm::ProgressBar::SetY | ( | const i32 | y | ) |

inline

## Member Data Documentation

## DefaultBackgroundColor

constexpr Color pu::ui::elm::ProgressBar::DefaultBackgroundColor = { 140, 140, 140, 255 }

staticconstexpr

## DefaultProgressColor

constexpr Color pu::ui::elm::ProgressBar::DefaultProgressColor = { 139, 195, 74, 255 }

staticconstexpr

The documentation for this class was generated from the following file:

- Plutonium/include/pu/ui/elm/elm_ProgressBar.hpp